
class Brw{
   
   pageJsonGrid; 
   pageJsonForm;

   constructor( pageJsonGrid , pageJsonForm ){     
     
     $("#page").text( 1 );
	 this.pageJsonGrid = pageJsonGrid;
	 this.pageJsonForm = pageJsonForm;
     this.refreshGrid(); // Leitura inicial

   }

   refreshGrid( nSkip = 0 ){
      
	  var auxPageJsonGrid = this.pageJsonGrid;	
	  
      $("#anterior").attr("disabled", true );

      $("#page").text( parseInt( $("#page").text() )  + nSkip);     
	  $("#registros thead").empty();    
      $("#registros tbody").empty();   
	  
      $.ajax({ 
              type: 'GET',
              url: auxPageJsonGrid,
              data: {
                     pagina: $("#page").text()
               },
              async: false,        
              dataType: 'json',
			  context: this, /* O contexto é o objeto grid */
              success: function( data ){
				    let head = "";
					let row;
					let ord;
				  
                    $("#anterior").attr("disabled", !data.PreviousPage );
                    $("#proximo").attr("disabled", !data.NextPage );
					switch ( data.Result ){
                     case 'OK':   

					    head += '<tr>';
						for ( let elem of data.Header ){
							head += '<th>' + elem + '</th>';
					    }
						head += '</tr>';
						$( head ).appendTo("#registros thead");

                        for ( let val of data.Rows ){
							
							/*
							Se tiver a chave definida (___pk) ela precisa ser armazenada
							*/
							if ( typeof val.___pk != "undefined" )
								row = '<tr ___pk=' + val.___pk + '>';
							else
								row = '<tr>';
							
							/* Conteúdo da coluna */
							ord = -1
							for ( let elem in val ){
								if ( elem != "___pk" )
									row += '<td width="'+ data.Width[++ord] +'">' + val[elem] + '</td>';
							}
							
							/* Tem botoões */
							if ( data.HasUpdateButton ){
							    row += '<td><button type="button" class="btn btn-primary btn-sm btn-update" data-toggle="modal" data-target="#formModal">Alterar</button></td>';
							}
							if ( data.HasDeleteButton ){
							    row += '<td><button type="button" class="btn btn-danger btn-sm btn-delete">Excluir</button></td>';
							}							
							row += "</tr>";

							$( row ).appendTo("#registros tbody");
							
						}	
						/* Se o botão de Update foi criado devo criar o evento ajax dele */
						if ( data.HasUpdateButton ){
							var gridThis = this; // Recebo o objeto grid
							$($("#registros tbody tr").find(".btn-update")).click(function() {
								  $.ajax({ 
										  type: 'POST',
										  url: "form.prg",
										  data: {
												 ___pk: $(this).closest("tr").attr('___pk') /* Mando a chave */
										   },
										  async: false,        
										  dataType: 'json',
										  success: function( data ){
											for ( let elem in data )
												$( "#formModal" ).find( "#" + elem ).val( data[elem] ); 
										  }  
								  }); // ajax
							 });
						}
						/* Se o botão de Delete foi criado devo criar o evento ajax dele */
						if ( data.HasDeleteButton ){
							var gridThis = this; // Recebo o objeto grid
							$($("#registros tbody tr").find(".btn-delete")).click(function() {
								  
								  $.ajax({ 
										  type: 'POST',
										  url: "delete.prg",
										  data: {
												 ___pk: $(this).closest("tr").attr('___pk') /* Mando a chave */
										   },
										  async: false,  
										  context: this,  
										  dataType: 'json',
										  success: function( data ){
											if ( data.Result == "OK" ){
												alert( "Exclusão realizada com sucesso!");
												var tr = $(this).closest("tr");
												tr.fadeOut(400, function() {
													tr.remove();  	    
													gridThis.refreshGrid(); // Refresh no objeto grid (contexto passado)
												});
											} else {
												alert( data.Message );
												
											}	
													
										  }  
								  }); // ajax
							 });
						}
                        
                        break;
                  }   
              }  
      }); // ajax
  }


  nextPage(){
     this.refreshGrid( +1 );
  }

  previousPage(){
     this.refreshGrid( -1 );
  }

  
}
